
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>数据库内核月报 － 2015 / 10-MySQL · 捉虫动态 · start slave crash 诊断分析 / iVAN</title>

    <meta name="description" content="数据库内核月报 － 2015 / 10-MySQL · 捉虫动态 · start slave crash 诊断分析 问题现象 研发同学执行下列语句序列 stop slave; set global slave_parallel_workers=0; start slave; 后程序 hang 住,不一会返回了2013 错误,即服务器连接异常中断,检查 mysqld error log, 发现在mysqld在将并行复制转化为串行复制的过程中异常 crash,其中错误信息为: [ERROR] Error reading slave worker configuration [ERROR] Error creati">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">数据库内核月报 － 2015 / 10-MySQL · 捉虫动态 · start slave crash 诊断分析</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<h2>问题现象</h2>
<p>研发同学执行下列语句序列</p>
<pre><code>stop slave; set global slave_parallel_workers=0; start slave;
</code></pre>
<p>后程序 hang 住，不一会返回了2013 错误，即服务器连接异常中断，检查 mysqld error log, 发现在mysqld在将并行复制转化为串行复制的过程中异常 crash，其中错误信息为：</p>
<pre><code>[ERROR] Error reading slave worker configuration
[ERROR] Error creating relay log info: Failed to initialize the worker info structure.
</code></pre>
<p>crash 堆栈为：</p>
<pre><code>#0  0x000000395fc0c69c in pthread_kill () from /lib64/libpthread.so.0
#1  0x00000000006b2425 in handle_fatal_signal (sig=11)
#2  &lt;signal handler called&gt;
#3  remove_info (this=0x2b19b775b000)
#4  Relay_log_info::mts_finalize_recovery
#5  0x0000000000920ec3 in slave_start_workers
#6  0x0000000000921c03 in handle_slave_sql
#7  0x000000395fc07851 in start_thread () from /lib64/libpthread.so.0
#8  0x000000395f4e767d in clone () from /lib64/libc.so.6
</code></pre>
<p>结合源码仔细分析上面的错误信息不难发现，在启动 SQL 线程初始化 worker 信息的过程中失败，从而引起了空指针异常。</p>
<h2>问题复现</h2>
<p>一个简单的 start slave 就能够导致 mysqld crash？应该不会那么简单，编写 testcase，试图在本地重现以上问题，测例如下：</p>
<pre><code>--source include/master-slave.inc
--source include/not_embedded.inc
--source include/not_windows.inc
--connection slave
stop slave;
set global slave_parallel_workers= 1;
start slave;

stop slave;
set global slave_parallel_workers= 0;
start slave;

--source include/rpl_end.inc
</code></pre>
<p>运行后果然没有能够重现问题，根据研发的同学反映在中断之前有一段时间命令是 hang 住的，于是断定 hang 问题与 crash 应该存在着联系，以上测例并不能将问题重现，于是与求助研发同学进行联调，在 hang 住的时候采集到了以下关键 pt-pmp 信息：</p>
<pre><code>pthread_cond_wait,os_cond_wait(os0sync.cc:214),os_event_wait_low(os0sync.cc:610),lock_wait_suspend_thread(lock0wait.cc:323),row_mysql_handle_errors(row0mysql.cc:1040),row_search_for_mysql(row0sel.cc:5064),ha_innobase::index_read(ha_innodb.cc:7668),ha_innobase::index_first(ha_innodb.cc:8041),ha_innobase::rnd_next(ha_innodb.cc:8138),handler::ha_rnd_next(handler.cc:2812),Rpl_info_table_access::scan_info(rpl_info_table_access.cc:287),Rpl_info_table::do_check_info(rpl_info_table.cc:444),Rpl_info_factory::decide_repository(rpl_info_factory.cc:567),Rpl_info_factory::create_worker(rpl_info_factory.cc:419),Relay_log_info::mts_finalize_recovery(rpl_rli.cc:328),slave_start_workers(rpl_slave.cc:6294),handle_slave_sql(rpl_slave.cc:6523),pfs_spawn_thread(pfs.cc:1858),start_thread(libpthread.so.0),clone(libc.so.6)

pthread_cond_wait,safe_cond_wait(thr_mutex.c:240),inline_mysql_cond_wait(mysql_thread.h:1151),start_slave_thread(rpl_slave.cc:1502),start_slave_threads(rpl_slave.cc:1587),start_slave(rpl_slave.cc:9485),start_slave(rpl_slave.cc:548),start_slave_cmd(rpl_slave.cc:690),mysql_execute_command(sql_parse.cc:3576),mysql_parse(sql_parse.cc:6958),dispatch_command(sql_parse.cc:1583),do_command(sql_parse.cc:1102),do_handle_one_connection(sql_connect.cc:1006),handle_one_connection(sql_connect.cc:922),pfs_spawn_thread(pfs.cc:1858),start_thread(libpthread.so.0),clone(libc.so.6)
</code></pre>
<p>可以看到在 start slave 后，sql thread 读取 slave_worker_info 初始化 worker 的过程中遇到了锁等待问题，于是断定 relay_log_info_repository=’table’，并且有其它的线程对 slave_worker_info中的记录上了Ｘ锁，但是是哪个线程确不是很清楚，因为只看到了一个线程在访问 slave_worker_info 表，然后再一次在hang的时候执行了下列操作：</p>
<pre><code>mysql&gt; SELECT r.trx_id waiting_trx_id, r.trx_mysql_thread_id waiting_thread, left(r.trx_query,20) waiting_query, concat(concat(lw.lock_type, ' '), lw.lock_mode) waiting_for_lock, b.trx_id blocking_trx_id, b.trx_mysql_thread_id blocking_thread, left(b.trx_query,20) blocking_query, concat(concat(lb.lock_type, ' '), lb.lock_mode) blocking_lock FROM information_schema.innodb_lock_waits w INNER JOIN information_schema.innodb_trx b ON b.trx_id = w.blocking_trx_id   INNER JOIN information_schema.innodb_trx r ON r.trx_id = w.requesting_trx_id INNER JOIN information_schema.innodb_locks lw ON lw.lock_trx_id = r.trx_id INNER JOIN information_schema.innodb_locks lb ON lb.lock_trx_id = b.trx_id\G
*************************** 1. row ***************************
  waiting_trx_id: 1313
  waiting_thread: 12
   waiting_query: NULL
waiting_for_lock: RECORD S
 blocking_trx_id: 1312
 blocking_thread: 6
  blocking_query: start slave
   blocking_lock: RECORD X
1 row in set (0.00 sec)

mysql&gt; show processlist;
+----+-------------+-----------------+-------+---------+------+-----------------------------------------+------------------+
| Id | User        | Host            | db    | Command | Time | State                                   | Info             |
+----+-------------+-----------------+-------+---------+------+-----------------------------------------+------------------+
|  2 | root        | localhost:57292 | test  | Sleep   |   16 |                                         |             |
|  3 | root        | localhost:57293 | test  | Sleep   |   16 |                                         |             |
|  6 | root        | localhost:57299 | test  | Query   |   15 | Waiting for slave thread to start       | start slave      |
|  7 | root        | localhost:57300 | test  | Sleep   |   16 |                                         |             |
| 11 | system user |                 | NULL  | Connect |   15 | Connecting to master                    |             |
| 12 | system user |                 | mysql | Connect |   15 | Waiting for the next event in relay log |             |
| 13 | root        | localhost       | test  | Query   |    0 | init                                    | show processlist |
+----+-------------+-----------------+-------+---------+------+-----------------------------------------+------------------+
7 rows in set (0.00 sec)
</code></pre>
<p>其中 information_schema.innodb_lock_waits，information_schema.innodb_locks，information_schema.innodb_trx 的信息可参考<a href="http://dev.mysql.com/doc/refman/5.6/en/innodb-i_s-tables.html" rel="external nofollow noreferrer">官方文档</a>。</p>
<p>从以上信息可以清楚地看到 start slave（blocking_thread: 6）获取了 slave_worker_info 中行记录的Ｘ锁，而 sql thread 线程 (waiting_thread: 12) 在获取 S 锁失败引起锁等待，进而获取信息失败返回NULL, 进而造成了空指针引用，mysqld crash，此时 start slave 与 sql thread 的资源竟争如下：</p>
<ul>
<li>start slave thread 获取 slave_work_info 记录的 X 锁，等待 sql thread 已启动的信号量，然后继续运行；</li>
<li>sql thread 被启动后，需要根据 slave_worker_info 为进行初始化，因此等待获取相关行的Ｓ锁;</li>
</ul>
<p>因此，start slave thread 与 sql thread 形成了死锁，分析到了现在还有两个疑问没有解释：</p>
<ul>
<li>start slave 为什么会访问 slave_worker_info 且一直持有锁资源?</li>
<li>为什么本地在测试的时候加上 relay_log_info_repository 的设置还是不能重现呢？</li>
</ul>
<p>继续研究，打开general log 后，发现有许多的 set autocommit=0 的语句，于是感觉可能是 autocommit 的问题，修改后测例如下：</p>
<pre><code>--source include/master-slave.inc
--source include/not_embedded.inc
--source include/not_windows.inc
--connection slave
stop slave;
set global relay_log_info_repository='table';
set global master_info_repository='table';
set global slave_parallel_workers= 1;
start slave;
--sleep 1

stop slave;
set autocommit=0;
set global slave_parallel_workers= 0;
start slave;

--source include/rpl_end.inc
</code></pre>
<p>运行后问题终于重现。。。</p>
<h2>问题原因</h2>
<p>有了以上的分析过程，不难看出，在 1) autocommit=0 &amp;&amp; 2) relay_log_info_repository=’table’ &amp;&amp; 3) 并行复制切换到串行复制时，就会触发此 bug, 原因有以下两个：</p>
<ul>
<li>start slave thread 在等待 sql thread 的过程中没有释放其占用的锁资源；</li>
<li>sql thread 在初始化 worker 信息时没有处理获取信息失败的情况。</li>
</ul>
<p>回到上面的问题：</p>
<ul>
<li>start slave 为什么会访问 slave_worker_info 且一直持有锁资源?</p>
<p>答：start slave 的过程中需要初始化 worker信息，执行 crash recovery 等一系列操作，对于已经执行的不再执行，对于没有执行的继续执行，详情见<code>global_init_info</code>，<code>mts_recovery_groups</code> 等函数，在autocommit=0 的情况下，start slave thread 没有commit 或者执行完之前是不会释放锁资源的。</li>
<li>为什么本地在测试的时候加上 relay_log_info_repository 的设置还是不能重现呢？
<p>答：本地在测试的时候，autocommit 默认值为1，因此不会重现。<br />
在上锁方面为什么会上写锁，可以参考：<code>Rpl_info_table::do_init_info</code> 函数；</li>
<li>影响范围<br />
经官方验证，5.6, 5.6.26, 5.6.28, 5.7.10 均存在此 bug。</li>
</ul>
<h2>问题扩展</h2>
<p>在排查问题的过程中发现 start slave 时会自动提交当前 session 之前已经操作的数据，然后开启一个新的事务，所以在使用 start slave 时要注意这个问题！</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-06 05:58:44</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong>         </div> -->
	</section>
	
	

		<div id="similar">

		<h3>数据库内核月报 － 2015 / 10-MySQL · 捉虫动态 · start slave crash 诊断分析的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MRDd1Gz.html" rel="bookmark">MySQL内核月报 2014&period;09-MySQL&CenterDot;　捉虫动态&CenterDot;GTID 和 DELAYED</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				描述 这是一个MySQL 5.6才有的bug,影响包含最新版本.涉及到的概念有GTID.DELAYED. 现象 在5.6主备都开启GTID-MODE的时候,备库同步线程停止,且Last_SQL_Error显示&quot;When @@SESSION.GTID_NEXT is set to a GTID, you must explicitly set it to a different value after a COMMIT or ROLLBACK. Please check GTID_NEXT var			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pdyna4z.html" rel="bookmark">MySQL内核月报 2014&period;10-MySQL&CenterDot;　捉虫动态&CenterDot;binlog重放失败</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				背景 在 MySQL 日常维护中,要回滚或者恢复数据,我们经常会用 binlog 来在数据库上重放,执行类似下面的语句: mysqlbinlog mysql-bin.000001 | mysql -hxxxx -Pxx -u 最近遇到了这样一个问题,在重放 binlog 时,mysqld 报这样的错 ERROR 1064 (42000) at line 25: You have an error in your SQL syntax; check the manual that correspo			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MRqWB3b.html" rel="bookmark">MySQL内核月报 2014&period;11-MySQL&CenterDot;　捉虫动态&CenterDot;SIGHUP 导致 binlog 写错</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				bug描述 这是5.6中和gtid相关的一个bug,当 mysqld 收到 sighup 信号 (比如 kill -1) 的时候,会 flush binlog,但是新生成binlog开头没写 Previous_gtids_log_event,这会导致下面 2 个问题: 这个时候 mysqld 重启的话,会发现再也起不来了,error log 里有这样的错 The binary log file 'mysql/mysql-bin.000020' is logically corrupted: Th			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/M6Zg3oM.html" rel="bookmark">MySQL内核月报 2014&period;09-MySQL&CenterDot;　捉虫动态&CenterDot;auto&lowbar;increment</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				背景: Innodb引擎使用B_tree结构保存表数据,这样就需要一个唯一键表示每一行记录(比如二级索引记录引用). Innodb表定义中处理主键的逻辑是: 1.如果表定义了主键,就使用主键唯一定位一条记录 2.如果没有定义主键,Innodb就生成一个全局唯一的rowid来定位一条记录 auto_increment的由来: 1.Innodb强烈推荐在设计表中自定义一个主键,因为rowid是全局唯一的,所以如果有很多表没有定义主键,就会在生成rowid上产生争用. row_id由mutex保护,并			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MlLY1OM.html" rel="bookmark">MySQL内核月报 2014&period;08-MySQL&CenterDot;　捉虫动态&CenterDot;Count&lpar;Distinct&rpar; ERROR</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				背景 MySQL现行版本中存在一个count(distinct)语句返回结果错误的bug,表现为,实际结果存在值,但是用count(distinct)统计后返回的是0. 原因分析 Count(distinct f)的语义就是计算字段f的去重总数,计算流程大致如下: 流程一: 1. 构造一个unique集合A1(用tree实现) 2. 对每个值都试图插入集合A1中 3. 若和A1中现有item重复则直接跳过,不重复则插入并+1 4. 完成后计算集合中元素个数. 细心的同学会看到上面的语句中有一个s			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/b2Yx1qz.html" rel="bookmark">MySQL内核月报 2014&period;10-MySQL&CenterDot;　捉虫动态&CenterDot;从库OOM</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				bug背景 官方最近发布的版本(5.7.5)修复了这样一个bug,主备复制场景下,如果主库和备库对应的表结构中有数据类型不一致,并且主库的 binlog 是 row 格式的,这时候如果主库对不一致的表做了一个大事务更新,备库在应用 relay-log 的时候报OOM(Out of Memory).bug地址在这里,主备数据类型不一致主要发生在这2种情况下: 主备库版本不一致,不同版本之间的数据类型可能存在不一致.用户在报这个bug时,就是在5.5到5.6的复制场景下,用到了时间类型,时间类型在5			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zwygOdM.html" rel="bookmark">MySQL内核月报 2014&period;12-MySQL&CenterDot;　捉虫动态&CenterDot;Opened tables block read only</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				背景 MySQL通过read_only参数来设置DB只读,这样MySQL实例就可以作为slave角色,只应用binlog,不接受用户修改数据.这样就可以保护master-slave结构中的数据一致性,防止双写风险. global read_only的实现方式 MySQL5.5版本通过三个步骤来设置read_only: 步骤1:获取global read lock,阻塞所有的写入请求 步骤2:flush opened table cache,阻塞所有的显示读写锁 步骤3:获取commit lock			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MgW1BmM.html" rel="bookmark">MySQL内核月报 2014&period;09-MySQL&CenterDot;　捉虫动态&CenterDot;GTID 和 binlog&lowbar;checksum</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				现象描述 在5.6主备环境下,主备都开启GTID-MODE,备库开启crc校验,主库不开.重启备库sql线程后,备库sql线程停止Last_Error显示:Relay log read failure: Could not parse relay log event entry. The possible reasons are: the master's binary log is corrupted(you can check this by running 'mysqlbinlog' on			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MyKoAlz.html" rel="bookmark">MySQL内核月报 2014&period;10-MySQL&CenterDot;　捉虫动态&CenterDot;崩溃恢复失败</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				现象 5.6版本,在创建InnoDB表过程中,若发生crash,会导致服务无法启动. 背景 每个InnoDB表A创建成功后有两个文件A.frm和A.ibd.建表流程如下: 1.创建A.frm 2.创建A.ibd 3.初始化A.ibd 4.将表A加入InnoDB字典 若crash发生在步骤2之后,则只保留一个完整的A.frm和一个空文件A.idb. 崩溃恢复 在上述的crash发生后,下一次启动则需要做崩溃恢复.崩溃恢复的一个逻辑是需要遍历数据目录下的所有.ibd文件,验证文件与字典的一致性. 对			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/9bBYgOz.html" rel="bookmark" class="title">DIV居中显示问题汇总</a>
					<div>
						 一.单行垂直居中 如果一个容器中只有一行文字,对它实现居中相对比较简单,我们只需要设置它的实际高度height和所在行的高度line-height相等即可.如: div {      height: ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/XMlxLOM.html" rel="bookmark" class="title">让PHP程序员工作更高效的四大神奇&lpar;1&rpar;</a>
					<div>
						做程序猿「媛」是一个苦逼的活,大周六地早起在技术群里招呼,看到没有啥人响应,说了一句,「估计都没有醒」,然后一位哥们抛过来,「在加班」 ! 做 Web 开发更是一个苦逼的活,不像是做 iOS,搞定客户 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/VMrED1b.html" rel="bookmark" class="title">三招预测网站关键词多久上首页</a>
					<div>
						首先来说明一下为什么要对关键词进行预测?这里要考虑两点:网站运作.公司运营(现在的投入是多少,多长时间能有回报),如果你是一个公司的优化师,你应该怎么和老总去说?再比如要搞一个项目,3个月网站排名上首 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/VMrVWOM.html" rel="bookmark" class="title">java&period;exe出错错误分析</a>
					<div>
						错误                            java.exe出错错误分析     作者:  CCBZZP     ---------------------- 序言 --------- ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/vMNaN4b.html" rel="bookmark" class="title">十天学会ASP之第三天</a>
					<div>
						学习目的:学会ACCEES数据库的使用,并建立一个将来要用的留言簿数据库.    首先,大家要安装OFFICE里面的ACCEES(我的演示是OFFICE XP版本),安装过程这里就不说了,安装好以后会 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zGjj4kp.html" rel="bookmark" class="title">Ajax改造，第2部分&colon;使用jQuery、Ajax、工具提示和lightbox改进现有站点</a>
					<div>
						Ajax 技术改变了大型商业 Web 应用程序的外观,但是许多较小的 Web 站点都不拥有重新构建整个用户界面(UI)的资源.Ajax 的一些新特性能够解决实际中的界面问题并改善用户体验.通过本系列文 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bB2y14b.html" rel="bookmark" class="title">Word 2003文档如何实现快速定位</a>
					<div>
						当你在Office 2003中的word中对长文档进行操作时,要想记住某个特定信息出现在什么地方是很困难的.但当你使用隐藏书签时,就可以快速导航到该信息.隐藏书签容易添加和使用,你可以把它们放在你想要 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/balaymz.html" rel="bookmark" class="title">PHP-图片用作submit进行提交</a>
					<div>
						在ASP中,可没有这么好哦!看例子:submit_0.php和submit_1.php 如下: &lt;!--文件submit_0.php --&gt;&lt;form action=&quot;su ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M919G4M.html" rel="bookmark" class="title">电脑没有声音怎么办</a>
					<div>
						  首先,电脑无音看似简单,其实有时问题比较复杂,既涉及到硬件方面的问题又涉及到软件方面的问题.还有因突然死机导致声卡不发声.小喇叭消失的现象也较为常见.因此,要先查明原因,看是软件故障还是硬件故障, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M0PyJJM.html" rel="bookmark" class="title">Photoshop绘制玻璃杯和烛光特效</a>
					<div>
						  先看完成图.   1)新建400*500文档,白背景. 2)先做桌面.新建图层1,设前景色为202/211/230,背景色为白色,执行云彩滤镜.复制这一层.回到图层1,执行风格化中的浮雕效果:角度 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MW1j0mz.html" rel="bookmark" class="title">PS高反差保留皮肤质感磨皮法以及添加亮晶晶的唇膏教程</a>
					<div>
						教程介绍用PhotoShop高反差保留皮肤质感的磨皮法和用阀值给美女加上亮晶晶的唇膏效果PS教程,方法挺好用,喜欢的同学可以学习一下 !        三联推荐:photoshop7.0迷你版免费下载 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MArX6Kp.html" rel="bookmark" class="title">Win8窗口透明化怎么设置&quest;</a>
					<div>
						  1.在Win8传统桌面右键鼠标,选择[个性化]选项,接着,弹出个性化窗口,点击其中[高对比度主题]中的[高对比度#1]. 2.随后,整个界面变成了黑底蓝框样式,接着,点击窗口下方[颜色],进入到[ ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mq81AYb.html" rel="bookmark" class="title">美课堂app上课缓存清理方法</a>
					<div>
						  1.打开美课堂客户端,进入到美课堂主界面以后,在界面最底部位置可以看到&quot;我的&quot;这个功能选项,点击我的功能进入,如下图. 2.进入到个人中心界面以后,找到底部&quot;设置&q ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bEWk7op.html" rel="bookmark" class="title">查看本机开放的端口号，查看某个端口号是否被占用，查看被占用的端口号被哪个进程所占用，如何结束该进程</a>
					<div>
						利用快捷键win+R键打开运行窗口.输入cmd回车打开命令提示符窗口 1:查看本机开放的端口,即已被占用的端口号.命令:netstat -an 部分结果列表:Proto  Local Address  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bamE7mb.html" rel="bookmark" class="title">常用RAID方案比较</a>
					<div>
						磁盘阵列(Redundant Arrays of Inexpensive Disks,RAID),即&quot;由廉价磁盘组成的冗余阵列&quot;. 以下是对常用的RAID方案作个总结和比较. RA ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pLmRYkz.html" rel="bookmark" class="title">&lbrack;译&rsqb; 渐进增强的 CSS 布局：从浮动到 Flexbox 到 Grid</a>
					<div>
						本文讲的是[译] 渐进增强的 CSS 布局:从浮动到 Flexbox 到 Grid, 原文地址:Progressively Enhancing CSS Layout: From Floats To F ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/My39jEz.html" rel="bookmark" class="title">windows下安装PhpDocumentor&lpar;phpdoc&rpar;笔记</a>
					<div>
						PhpDocumentor简介 PHPDocumentor是一个用PHP写的工具,对于有规范注释的php程序,它能够快速生成具有相互参照,索引等功能的API文档.老的版本是phpdoc,从1.3.0开 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zeRKoNb.html" rel="bookmark" class="title">基金投资方法札记</a>
					<div>
						上一篇已经总结了'安心睡大觉'的基金投资方法.这一篇主要是把原来临时记录在手机上的一些札记整理发出来.   2015/07/07 11:05 反思:股市变化较快时,做短线,则应该以周指标为主:反之,则 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M6ZJRgM.html" rel="bookmark" class="title">评论：互联网让生活变好还是变糟</a>
					<div>
						&lt;数字升华:迷思.权力和网络空间&gt; □ 专栏主持 王 佩 我手边有一本2006年12月25日的&lt;时代周刊&gt;.在封面正中央,有一面用锡箔纸做成的小镜子.旁边的文字写着:&quot ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MgRkOAb.html" rel="bookmark" class="title">PHP中修改Linux或Unix口令方法</a>
					<div>
						必须安装下面的工具和软件: –修改口令的Shell脚本; – Sudo访问权; – Apache or Lighttpd web服务器; – PHP服务端程序. 步骤1:安装可以修改用户口令的shel ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zJA8P2p.html" rel="bookmark" class="title">迭代-从数据库中获取的数据在jsp页面上的显示问题</a>
					<div>
						问题描述 从数据库中获取的数据在jsp页面上的显示问题 做一个项目的时候,从数据库获取数据,用迭代的方式在前台显示,只能显示一部分的信息,就好像是有一个固定空间似的,只要内容超出了这个空间,就不能显示 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pnR792p.html" rel="bookmark" class="title">如何取消 IE 按上一頁的動作</a>
					<div>
						问题描述 如何取消IE按上一頁的動作IE按上一頁是去指定頁面或停留該頁面 解决方案 解决方案二:用AJAX技术可实现.百度.解决方案三:不用ajax可以實現嗎?解决方案四:实话有点没看明白?你是不要这 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pkAnXjb.html" rel="bookmark" class="title">mysql&plus;tomcat6&period;0 乱码问题</a>
					<div>
						问题描述 最近做了一个小系统,在tomcat上运行,在自己机子上运行时毫无问题,到另一台机子测试时出现了乱码,过滤器加了,页面和数据库统一utf-8编码,tomcat打印信息:&quot;insert ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mr2K9vM.html" rel="bookmark" class="title">高德已经全身进入了阿里的大门</a>
					<div>
						就在我还在深入细致的研究京东IPO文件时,突然传出凡客G轮融资,当我还没来得急去好好关注转向凡客时,阿里又要全资收购高德了.这样的速度实在是太快了,要时刻跟着风向走确实需要额外付出不少精力. 抽空看了 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bKqmxap.html" rel="bookmark" class="title">Android 开发 使用WebUploader解决安卓微信浏览器上传图片中遇到的bug&lowbar;Android</a>
					<div>
						先给大家分析下微信浏览器上传图片bug的原因 微信在新版本中采用的是自己的X5内核浏览器,而在较老的版本中还有可能是安卓的原生浏览器.具体的环境我也不太了解,但是经过实际多台安卓机型的测试,我采取的方 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mlmogap.html" rel="bookmark" class="title">Python基础教程之字符串</a>
					<div>
						1 基本字符串操作 2 字符串格式化:精简版 2.1 用字符串格式化操作符 2.2 用string的Template格式化字符串 3 字符串格式化:完整版 3.1 转换说明符 3.2 简单转换 3.3 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pmVJBDz.html" rel="bookmark" class="title">c&plus;&plus;-很不懂    k&plus;&plus;到底什么意思</a>
					<div>
						问题描述 很不懂 k++到底什么意思 #include using namespace std; int main() { int i,j,sum=0,a[50],t; int k; //i开始从一加 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MNm8D7b.html" rel="bookmark" class="title">雨润：道德烙印下的品牌</a>
					<div>
						雨润从建立之初就非常注重品牌建设,虽然说&quot;酒香不怕巷子深&quot;,但是酒香更需人来称赞,品牌才能铸就企业的辉煌.品牌是一个企业生存与否的关键条件,如果没有品牌,企业的生存无从谈起.雨润建 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pk7a5rp.html" rel="bookmark" class="title">巴茨谈童年到职场经历：酒吧女郎变身雅虎CEO</a>
					<div>
						雅虎首席执行官卡罗尔·巴茨(Carol Bartz)日前接受了&lt;时尚先生&gt;(Esquire)女性版的采访. 巴茨在访谈中谈到了自己的童年.职场生涯.以及对工作的诸多看法.巴茨在访谈中表示, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z7wAVaz.html" rel="bookmark" class="title">请教下这样注册button事件为什么没有效果</a>
					<div>
						问题描述 代码: TableLayout tableLayout = (TableLayout) this.getLayoutInflater().inflate(R.layout.activity_ ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.035 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
